import { UrlAdaptor } from '@syncfusion/ej2-data';

export class CustomAdaptor extends UrlAdaptor {
  processResponse(data, ds, query, xhr, request, changes) {
    // Map task data to match expected format
    if (data.count?.toString() === "0") {
      return data
    }
    data.result = data.result.map((task) => {
      task.start_date_actual = new Date(task.start_date_actual)
      task.start_date_expected = new Date(task.start_date_expected)
      return task
    })
    return data
  }

  batchRequest(dm, changes, e, query, original) {
    const request = super.batchRequest(dm, changes, e, query, original)
    let aux = JSON.parse(request.data)
    delete aux.action
    aux.added = aux.added.map((task) => {
      delete task.id
      delete task.phase_id
      task.start_date_actual = task.start_date_actual?.substring(0, 10);
      task.start_date_expected = task.start_date_expected?.substring(0, 10);
      return task
    })
    request.data = JSON.stringify(aux)
    return request
  }
}


